%% Computing the Social Force
p=[0 0];%panic weight parameter: 0->individual characteristics, 1->crowd characteristics
tau=1;%relaxation parameter
%Vopt_av=mean(Vopt,3);
V_des=zeros(size(Opt_loc));%preallocate
F_int=zeros(size(Opt_loc));%preallocate
% F_int_vidx=zeros(size(Voptx));
% F_int_vidy=zeros(size(Vopty));
for i = 2:size(video,4)
    for x = 1:size(Opt_av,1)
        for y = 1:size(Opt_av,2)
            V_des(x,y,i,1)=(1-p(1)).*Opt_loc(x,y,i,1)+p(1).*Opt_av(x,y,i,1);%Desired x-velocity
            V_des(x,y,i,2)=(1-p(2)).*Opt_loc(x,y,i,2)+p(2).*Opt_av(x,y,i,2);%Desired y-velocity
            F_int(x,y,i,1)=(1./tau).*(V_des(x,y,i,1)-Opt_av(x,y,i,1))-(Opt_av(x,y,i,1)-Opt_av(x,y,i-1,1)); %estimate Interaction force x
            F_int(x,y,i,2)=(1./tau).*(V_des(x,y,i,2)-Opt_av(x,y,i,2))-(Opt_av(x,y,i,2)-Opt_av(x,y,i-1,2)); %estimate Interaction force y
        end
    end
end

%% Calculate and display force flow
S_f=zeros(size(X,1),size(X,2),size(video,4)); %preallocation
[X,Y] = meshgrid(20:20:size(video,1)-20,20:20:size(video,2)-20); %initial particle positions
figure;
for i=1:size(video,4) %scroll through frames
    for x = 1:size(X,1) %scroll through particle x-values
        for y = 1:size(X,2) %scroll through particle y-values
%             for l = -5:5
%                 for j = -5:5 %map force flow of particles back on image frame
%                     if (round(X(x,y))+l>=1) && (round(X(x,y))+l<=size(video,1)) && (round(Y(x,y))+j>=1) && (round(Y(x,y))+j<=size(video,2))
            S_f(x,y,i)=S_f(x,y,i)+sqrt(F_int(x,y,i,1).^2+F_int(x,y,i,2).^2); %force flow
            X(x,y) = X(x,y)+Opt_av(x,y,i,1);
            Y(x,y) = Y(x,y)+Opt_av(x,y,i,2);
%                     end
%                 end
%             end
        end
    end 
    %calculate new particle positions
    %show force flow overlayed on video
    imshow(video(:,:,:,i)); hold on;
    Ximg=[1 size(video,2)];
    Yimg=[1 size(video,1)];
    F_img=imagesc(Ximg,Yimg,transpose(S_f(:,:,i)));
    alpha(F_img,0.5); %make force flow 50% transparent
    colorbar
    caxis([0 100])
	hold off;
    drawnow;
    [row,col]=find(round(X)>=(size(video,1)-10));
       if size(row,1)>0
           for idx = 1:size(row) %particle x-coordinate
                X(row(idx),col(idx))=Xint(row(idx),col(idx));
                Y(row(idx),col(idx))=Yint(row(idx),col(idx));
           end
       end
       [row,col]=find(round(X)<=10);
       if size(row,1)>0
            for idx = 1:size(row) %particle x-coordinate
                X(row(idx),col(idx))=Xint(row(idx),col(idx));
                Y(row(idx),col(idx))=Yint(row(idx),col(idx));
            end
       end
       [row,col]=find(round(Y)>=(size(video,2)-10));
       if size(row,1)>0
            for idx = 1:size(row) %particle x-coordinate
                X(row(idx),col(idx))=Xint(row(idx),col(idx));
                Y(row(idx),col(idx))=Yint(row(idx),col(idx));
            end
       end
       [row,col]=find(round(Y)<=10);
       if size(row,1)>0
            for idx = 1:size(row) %particle x-coordinate
                X(row(idx),col(idx))=Xint(row(idx),col(idx));
                Y(row(idx),col(idx))=Yint(row(idx),col(idx));
            end
       end
%     if mod(i,120) == 0 %reset particle location after 120 frames
%         [X,Y] = meshgrid(10:10:size(video,1)-10,10:10:size(video,2)-10);
%     end
end