clear,close all;
%% import data
v = VideoReader('./data/StandingStill1_compr_8fps_real.avi');
video = zeros(v.Height,v.Width,3,round(v.Duration*v.FrameRate),'uint8'); %preallocate data for video, [height, width, color channels, frames]
i = 1;
while hasFrame(v) % extract all the frames in the video (for surveillance continuous data extraction needs to be applied)
    video(:,:,:,i) = readFrame(v);
%     imshow(video(:,:,:,i));drawnow;
    i = i+1;
end
% figure;colormap jet
%% compute optical flow (Piotr's Master Toolbox)
Voptx = zeros(size(video,1),size(video,2),size(video,4)); %preallocate optical flow matrix [x-coordinate,y-coordinate,frame,optical flow direction (1 = x, 2 = y)]
Vopty = zeros(size(video,1),size(video,2),size(video,4));
for i = 2:size(video,4) %for every frame
    I1 = video(:,:,:,i-1);
    I2 = video(:,:,:,i);
    [Vx,Vy] = opticalFlow(rgb2gray(I1),rgb2gray(I2),'smooth',1,'radius',10,'type','LK'); %use Piotr,s optical flow
    Voptx(:,:,i) = Vx;
    Vopty(:,:,i) = Vy;
end