[X,Y] = meshgrid(20:20:size(video,1)-20,20:20:size(video,2)-20); %initial particle positions
Opt_dif=zeros(size(X,1),size(X,2),size(video,4),2); %preallocating
SocialForce=zeros(size(X,1),size(X,2),size(video,4));
Vector.relsize=zeros(size(X,1),size(X,2),size(video,4));
Vector.angledif=zeros(size(X,1),size(X,2),size(video,4));
S=zeros(size(X,1),size(X,2),size(video,4));
w1=1./0.0060.*5; %weight factor of vector relative size
w2=1./0.4748; %weight factor of vector angle difference
w3=1./3.6179.*0; %weight factor of Social Force
for i = 2:(size(video,4)-1)
    for x = 1:size(X,1) %particle x-coordinate
        for y = 1:size(X,2) %particle y-coordinate
            Opt_dif(x,y,i,1)=Opt_av(x,y,i,1)-Opt_loc(x,y,i,1); %difference between average and local velocity (x-direction)
            Opt_dif(x,y,i,2)=Opt_av(x,y,i,2)-Opt_loc(x,y,i,2); %difference between avarage and local velocity (y-direction)
            Vector.relsize(x,y,i)=sqrt(Opt_dif(x,y,i,1).^2+Opt_dif(x,y,i,2).^2); %relative size Opt_dif to Opt_av
            Vector.angledif(x,y,i)=mod(abs(tan(Opt_av(x,y,i,2)./Opt_av(x,y,i,1))-tan(Opt_loc(x,y,i,2)./Opt_loc(x,y,i,1))),2*pi); %relative angular difference average direction to local direction (rad)
            SocialForce(x,y,i)=sqrt(F_int(x,y,i,1).^2+F_int(x,y,i,2).^2);
            %if Vector.relsize(x,y,i)>=0.4
            S(x,y,i)=S(x,y,i-1)+w1.*Vector.relsize(x,y,i)+w2.*Vector.angledif(x,y,i)+w3.*SocialForce(x,y,i);
           %end
            %if Vector.angledif>1.5*pi
                %S(x,y,i)=S(x,y,i-1+w2.*Vector.angle(x,y,i);
            %end
        end
    end
end

%% baseline determination
%time average
for x=1:size(X,1)
    for y=1:size(X,2)
        Tmean.angledif(x,y)=mean(Vector.angledif(x,y,:));
        Tmean.relsize(x,y)=mean(Vector.relsize(x,y,:));
        Tmean.SocialForce(x,y)=mean(SocialForce(x,y,:));
        Tmean.S(x,y)=mean(S(x,y,:));
    end
end
% [value, location] = max(Tmean.relsize(:));
% [R,C] = ind2sub(size(Tmean.relsize),location);
% Xabn=Xint(R,C);
% Yabn=Yint(R,C);
figure()
%histfit(Tmean.S(:),100,'kernel');
Smeanps=(mean(Tmean.S(:))./size(video,4)).*8;
Sstdps=(std(Tmean.S(:))./size(video,4)).*8;
Stimes=zeros(size(X,1),size(X,2));
Sps=zeros(size(X,1),size(X,2));
%% show in video
[X,Y] = meshgrid(20:20:size(video,1)-20,20:20:size(video,2)-20); %initial particle positions
a=1;
b=1;
row2=[];
col2=[];
clear i x y Sps smod surprise surprisesave Spssave
for i=2:size(video,4)
     if i==4*a
        a=a+1;
        for x=1:size(X,1)
            for y=1:size(X,2)
                row2=[];
                col2=[];
                Sps(x,y)=S(x,y,i)./i.*4;
                Spssave(x,y,a)=S(x,y,i)./i.*4;
                smod(x,y)=newsm(0.7);
                smod(x,y).options.debug = 0;
                smod(x,y).options.factordecay='yes';
                smod(x,y).options.alphaupdate='poisson';
                smod(x,y)=runsm(Sps(x,y),smod(x,y));
                surprise(x,y)=smod(x,y).surprise;
                surprisesave(x,y,a)=smod(x,y).surprise;
                [row2,col2]=find(surprise>=600);
                X(x,y) = X(x,y)+Opt_av(x,y,i,2);
                Y(x,y) = Y(x,y)+Opt_av(x,y,i,1);
            end
        end
     else
         for x=1:size(X,1)
             for y=1:size(X,2)
                 X(x,y) = X(x,y)+Opt_av(x,y,i,2);
                 Y(x,y) = Y(x,y)+Opt_av(x,y,i,1);
             end
         end
     end
%             if Stimes(x,y)>=3
%                 b=b+1;
%                 R(b)=x;
%                 C(b)=y;
%             end
    X2 = reshape(X,[1,size(X,1)*size(X,2)]);
    Y2 = reshape(Y,[1,size(Y,1)*size(Y,2)]);
    imshow(video(:,:,:,i)); hold on;
        if size(row2,1)>0
            for idx = 1:size(row2)
                scatter(Y(row2(idx),col2(idx)),X(row2(idx),col2(idx)),100,'y','o')
            end
        end
    %scatter(Y2(C),X2(R),100,'y','o');
	hold off;
    drawnow;
    [row,col]=find(round(X)>=(size(video,1)-10));
       if size(row,1)>0
           for idx = 1:size(row) %particle x-coordinate
                X(row(idx),col(idx))=Xint(row(idx),col(idx));
                Y(row(idx),col(idx))=Yint(row(idx),col(idx));
           end
       end
       [row,col]=find(round(X)<=10);
       if size(row,1)>0
            for idx = 1:size(row) %particle x-coordinate
                X(row(idx),col(idx))=Xint(row(idx),col(idx));
                Y(row(idx),col(idx))=Yint(row(idx),col(idx));
            end
       end
       [row,col]=find(round(Y)>=(size(video,2)-10));
       if size(row,1)>0
            for idx = 1:size(row) %particle x-coordinate
                X(row(idx),col(idx))=Xint(row(idx),col(idx));
                Y(row(idx),col(idx))=Yint(row(idx),col(idx));
            end
       end
       [row,col]=find(round(Y)<=10);
       if size(row,1)>0
            for idx = 1:size(row) %particle x-coordinate
                X(row(idx),col(idx))=Xint(row(idx),col(idx));
                Y(row(idx),col(idx))=Yint(row(idx),col(idx));
            end
       end
end
