%% compute particle advection
[X,Y] = meshgrid(20:20:size(video,1)-20,20:20:size(video,2)-20); %initial particle positions
[Xint,Yint] = meshgrid(20:20:size(video,1)-20,20:20:size(video,2)-20);
Opt_av = zeros(size(X,1),size(X,2),size(video,4),2);%preallocating
w_av = fspecial('gaussian',[21,21]); %filter for calculating the weighted average optical flow of a particle
Opt_loc= zeros(size(X,1),size(X,2),size(video,4),2);%preallocating

%initialize
X2 = reshape(X,[1,size(X,1)*size(X,2)]);
Y2 = reshape(Y,[1,size(Y,1)*size(Y,2)]);
I = video(:,:,:,1);
figure;
imshow(I);hold on;
scatter(Y2,X2,5,'y','filled');
hold off;
pause
%advection
tic
for i = 2:size(video,4)
    for x = 1:size(X,1) %particle x-coordinate
        for y = 1:size(X,2) %particle y-coordinate
            X_ROI = round([X(x,y)-10:X(x,y)+10]); %determine Region Of Interest
            Y_ROI = round([Y(x,y)-10:Y(x,y)+10]);
            if (min(X_ROI>0) && max(X_ROI) <= size(I,1)) && (min(Y_ROI >0) && max(Y_ROI) <= size(I,2))
                Opt_ROIx = Voptx(X_ROI,Y_ROI,i); % extract optical flow of ROI, TO DO: fix matrix dimensions exceeding
                Opt_ROIy = Vopty(X_ROI,Y_ROI,i);
            else
                Opt_ROIx = zeros(size(w_av,1),size(w_av,2),1);
                Opt_ROIy = zeros(size(w_av,1),size(w_av,2),1);
            end
            Opt_av(x,y,i,1) = sum(sum(w_av.*Opt_ROIx(:,:,1))); %calculate weighted average (x-direction)
            Opt_av(x,y,i,2) = sum(sum(w_av.*Opt_ROIy(:,:,1))); %calculate weighted average (y-direction)
            Opt_loc(x,y,i,1)= Voptx(round(X(x,y)),round(Y(x,y)),i); %Local particle velocity (x-direction)
            Opt_loc(x,y,i,2)= Vopty(round(X(x,y)),round(Y(x,y)),i); %Local particle velocity (y-direction)
            X(x,y) = X(x,y) + Opt_av(x,y,i,2);
            Y(x,y) = Y(x,y) + Opt_av(x,y,i,1);
        end
    end
    %calculate new particle positions
%     X = X+Opt_av(:,:,i,1);
%     Y = Y+Opt_av(:,:,i,2);
    X2 = reshape(X,[1,size(X,1)*size(X,2)]);
    Y2 = reshape(Y,[1,size(Y,1)*size(Y,2)]);
    imshow(video(:,:,:,i)); hold on;
    scatter(Y2,X2,5,'y','filled');
	hold off;
    drawnow;
%     pause
       [row,col]=find(round(X)>=(size(video,1)-10));
       if size(row,1)>0
           for idx = 1:size(row) %particle x-coordinate
                X(row(idx),col(idx))=Xint(row(idx),col(idx));
                Y(row(idx),col(idx))=Yint(row(idx),col(idx));
           end
       end
       [row,col]=find(round(X)<=10);
       if size(row,1)>0
            for idx = 1:size(row) %particle x-coordinate
                X(row(idx),col(idx))=Xint(row(idx),col(idx));
                Y(row(idx),col(idx))=Yint(row(idx),col(idx));
            end
       end
       [row,col]=find(round(Y)>=(size(video,2)-10));
       if size(row,1)>0
            for idx = 1:size(row) %particle x-coordinate
                X(row(idx),col(idx))=Xint(row(idx),col(idx));
                Y(row(idx),col(idx))=Yint(row(idx),col(idx));
            end
       end
       [row,col]=find(round(Y)<=10);
       if size(row,1)>0
            for idx = 1:size(row) %particle x-coordinate
                X(row(idx),col(idx))=Xint(row(idx),col(idx));
                Y(row(idx),col(idx))=Yint(row(idx),col(idx));
            end
       end
 %      [row2,col2]=find(round(Y)>=(size(video,2)-10));
 %       if size(row2,1)>0
  %          Y(row2,col2)=Yint(row2,col2);
 %           X(row2,col2)=Xint(row2,col2);
 %       end
%     if mod(i,120) == 0
%         [X,Y] = meshgrid(10:10:size(video,1)-10,10:10:size(video,2)-10);
%     end
end
toc


%% visualize
[X,Y] = meshgrid(1:20:size(video,2),1:20:size(video,1));
Vopt_visx = Voptx(1:20:end,1:20:end,:); % for visualisation, decrease amount of arrows
Vopt_visy = Vopty(1:20:end,1:20:end,:);
V_opt_avx = mean(Vopt_visx,3);
V_opt_avy = mean(Vopt_visy,3);
for x = 1:size(Vopt_visx,1)
    for y = 1:size(Vopt_visy,2)
        if sqrt(Vopt_visx(x,y,:).^2+Vopt_visy(x,y,:).^2) < 0.5 %don't display too small arrows
            Vopt_visx(x,y,:) = 0; Vopt_visy(x,y,:) = 0;
        end
    end
end
figure;
 I = video(:,:,:,i-1);
imshow(I);hold on; %frame
quiver(X,Y,V_opt_avx(:,:,:),V_opt_avy(:,:,:),'AutoScaleFactor',3,'color','blue') %optical flow field
% for i = 2:size(Vopt_vis,3)
%     Vx = Vopt_vis(:,:,i-1,1);
%     Vy = Vopt_vis(:,:,i-1,2);
%     
%     I = video(:,:,:,i-1);
%     imshow(I);hold on; %frame
%     quiver(X,Y,Vx,Vy,'AutoScaleFactor',3,'color','blue') %optical flow field
%     drawnow; %forces matlab to plot image before continuing
% end